239. Sliding Window Maximum

来源:互联网 发布:数据库服务器选择 编辑:程序博客网 时间:2024/06/05 23:06

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

For example,
Given nums = [1,3,-1,-3,5,3,6,7], and k = 3.

Window position                Max---------------               -----[1  3  -1] -3  5  3  6  7       3 1 [3  -1  -3] 5  3  6  7       3 1  3 [-1  -3  5] 3  6  7       5 1  3  -1 [-3  5  3] 6  7       5 1  3  -1  -3 [5  3  6] 7       6 1  3  -1  -3  5 [3  6  7]      7

Therefore, return the max sliding window as [3,3,5,5,6,7].

Note: 
You may assume k is always valid, ie: 1 ≤ k ≤ input array's size for non-empty array.

Follow up:
Could you solve it in linear time?

Hint:

  1. How about using a data structure such as deque (double-ended queue)?
  2. The queue size need not be the same as the window’s size.
  3. Remove redundant elements and the queue should store only elements that need to be considered.
题意:给定一个数组,然后以一个k大小的窗口在数组上滑动,返回每次窗口对应中的最大值。

思路:原本以为前k个元素建立一个堆,然后后续的元素一个一个的替换进堆里,然后每次返回出最大的元素,问题在于无法找到堆中要加入的那个元素的对应位置,且时间复杂度不是线性。按照提示的思路进行,先建立一个双端队列,然后每加入一个元素都把队列中这个元素之前的比这个元素小的值给删除,因为他们不可能是最大值了,这样维持了双端队列中从左至右元素依次递减的特性(最大的就在队列第一个位置),每次新加入元素前,检测队列里第一个元素之是否已经移出窗口,然后再进行操作。队列里存放的是数组里值对应的下标,这样方便计算队列首元素是否已经滑出窗口。

class Solution {public:vector<int> maxSlidingWindow(vector<int>& nums, int k) {int len = nums.size();if (len == 0)return vector<int>();vector<int> res(len - k+1);deque<int> mydeque(1, 0);//队列里存储的是数组的下标for (int i = 1; i < k; i++){for (int j = mydeque.size() - 1; j >= 0; j--){if (nums[mydeque[j]] < nums[i]){mydeque.pop_back();}}mydeque.push_back(i);}res[0] = nums[mydeque[0]];for (int i = k; i < len; i++){if (mydeque[0] < i-k+1){mydeque.pop_front();}for (int j = mydeque.size() - 1; j >= 0; j--){if (nums[mydeque[j]] < nums[i]){mydeque.pop_back();}}mydeque.push_back(i);res[i - k + 1] = nums[mydeque[0]];}return res;}};






0 0